diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/channel.h ircd-hybrid-fuis/include/channel.h
--- ircd-hybrid-7.0rc9/include/channel.h	Fri Jan 31 18:00:25 2003
+++ ircd-hybrid-fuis/include/channel.h	Wed Mar 12 16:18:57 2003
@@ -73,6 +73,7 @@
 #ifdef HALFOPS
   dlink_list      halfops;
 #endif
+  dlink_list	  nokick;
   dlink_list      voiced;
   dlink_list      peons;                /* non ops, just members */
   dlink_list	  deopped;              /* users deopped on sjoin */
@@ -180,7 +181,8 @@
 #ifdef INTENSIVE_DEBUG
 void do_channel_integrity_check(void);
 #endif
-
+void DelNokick(struct Channel *cptr, struct Client *source_p);
+void AddNokick(struct Channel *cptr, struct Client *source_p);
 void set_channel_topic(struct Channel *chptr, const char *topic, const char *topic_info, time_t topicts); 
 void free_topic(struct Channel *);
 int allocate_topic(struct Channel *);
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/channel_mode.h ircd-hybrid-fuis/include/channel_mode.h
--- ircd-hybrid-7.0rc9/include/channel_mode.h	Mon Oct 28 16:09:20 2002
+++ ircd-hybrid-fuis/include/channel_mode.h	Sun Feb  9 08:21:20 2003
@@ -100,6 +100,12 @@
 #define MODE_EXCEPTION  0x0800
 #define MODE_INVEX	0x2000
 #define MODE_HIDEOPS    0x4000
+#define MODE_NOCOLOR    0x8000
+#define MODE_JOINF	    0x10000
+#define MODE_NOCTCP	    0x20000
+#define MODE_NOTALK	    0x40000
+#define MODE_NOSPAM	    0x80000
+#define MODE_NOREPEAT   0x100000
 
 /*
  * mode flags which take another parameter (With PARAmeterS)
@@ -118,6 +124,7 @@
 #define ParanoidChannel(x)	((x) && ((x)->mode.mode &\
 			        (MODE_PRIVATE|MODE_INVITEONLY))==\
 		                (MODE_PRIVATE|MODE_INVITEONLY))
+#define NoRepeatChannel(x)      ((x) && ((x)->mode.mode & MODE_NOREPEAT))
 
 struct ChModeChange
 {
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/client.h ircd-hybrid-fuis/include/client.h
--- ircd-hybrid-7.0rc9/include/client.h	Sun Feb 16 17:54:35 2003
+++ ircd-hybrid-fuis/include/client.h	Sun Apr 13 12:17:28 2003
@@ -50,7 +50,6 @@
 
 #define CLIENT_BUFSIZE 512      /* must be at least 512 bytes */
 
-
 /*
  * pre declare structs
  */
@@ -61,6 +60,12 @@
 struct Client;
 struct LocalUser;
 
+struct Repeat {
+  struct Channel *chptr;      /* last phrase block */
+  char *text;
+  time_t lastphrase;
+};
+
 /*
  * Client structures
  */
@@ -68,6 +73,7 @@
 {
   dlink_list     channel;       /* chain of channel pointer blocks */
   dlink_list     invited;       /* chain of invite pointer blocks */
+  dlink_list    repeat;         /* chain of last phrases per channel blocks */
   char*          away;          /* pointer to away message */
   time_t         last_away;     /* Away since... */
   time_t         last;
@@ -81,6 +87,7 @@
   char id_key[IDLEN + 1];
   /* When did we detach from them, if they are detached... */
   time_t            last_detach_time;
+  int known;    /* USER came from particular type of client */
 };
 
 struct Server
@@ -180,6 +187,8 @@
    * considered a read-only field after the client has registered.
    */
   char              host[HOSTLEN + 1];     /* client's hostname */
+
+  char              realhost[HOSTLEN + 1];     /* client's hostname */
   /*
    * client->info for unix clients will normally contain the info from the 
    * gcos field in /etc/passwd but anything can go here.
@@ -202,7 +211,8 @@
   
   
   struct LocalUser *localClient;
-
+  time_t ns_reg; /* when the nick was registered in NS */
+  
 };
 
 struct LocalUser
@@ -422,35 +432,44 @@
 /* user information flags, only settable by remote mode or local oper */
 #define FLAGS_OPER         0x20000 /* Operator */
 #define FLAGS_ADMIN        0x40000 /* Admin on server */
+#define FLAGS_NK_ID        0x80000 /* NetKeeper */
+#define FLAGS_OS_ID        0x100000 /* Idented in OS */
+#define FLAGS_NS_ID        0x200000 /* Idented in NS */
+#define FLAGS_SILENCE      0x400000 /* user's mode +S */
+#define FLAGS_AVFH         0x800000 /* user's mode +h */
+#define FLAGS_TRANSWIN     0x1000000 /* translate cyrillic Windows-1251 */
+#define FLAGS_TRANSISO     0x2000000 /* translate cyrillic ISO-8859-5 */
+#define FLAGS_NODCC        0x4000000 /* stop sending forbidden files */
+#define FLAGS_NOLIST       0x8000000 /* hide channel list from whois*/
+#define FLAGS_NOIDLE       0x10000000 /* hide idle from whois */
 
 #define FLAGS_ALL	   FLAGS_SERVNOTICE
 
 
 /* overflow flags */
-#define FLAGS2_EXEMPTGLINE  0x0001	/* client can't be G-lined */
-#define FLAGS2_EXEMPTKLINE  0x0002      /* client is exempt from kline */
-#define FLAGS2_NOLIMIT      0x0004      /* client is exempt from limits */
-#define FLAGS2_RESTRICTED   0x0008      /* client cannot op others */
+#define FLAGS2_EXEMPTKLINE  0x0001      /* client is exempt from kline */
+#define FLAGS2_NOLIMIT      0x0002      /* client is exempt from limits */
+#define FLAGS2_RESTRICTED   0x0004      /* client cannot op others */
 
 /* oper priv flags */
 #define FLAGS2_OPER_GLOBAL_KILL 0x0020  /* oper can global kill */
 #define FLAGS2_OPER_REMOTE      0x0040  /* oper can do squits/connects */
 #define FLAGS2_OPER_UNKLINE     0x0080  /* oper can use unkline */
-#define FLAGS2_OPER_GLINE       0x0100  /* oper can use gline */
 #define FLAGS2_OPER_N           0x0200  /* oper can umode n */
 #define FLAGS2_OPER_K           0x0400  /* oper can kill/kline */
 #define FLAGS2_OPER_DIE         0x0800  /* oper can die */
 #define FLAGS2_OPER_REHASH      0x1000  /* oper can rehash */
 #define FLAGS2_OPER_ADMIN       0x2000  /* oper can set umode +a */
+#define FLAGS2_OPER_OPERWALL    0x4000  /* oper can do /OPERWALL */
 #define FLAGS2_OPER_FLAGS       (FLAGS2_OPER_GLOBAL_KILL | \
                                  FLAGS2_OPER_REMOTE | \
                                  FLAGS2_OPER_UNKLINE | \
-                                 FLAGS2_OPER_GLINE | \
                                  FLAGS2_OPER_N | \
                                  FLAGS2_OPER_K | \
                                  FLAGS2_OPER_DIE | \
                                  FLAGS2_OPER_REHASH| \
-                                 FLAGS2_OPER_ADMIN)
+                                 FLAGS2_OPER_ADMIN | \
+                                FLAGS2_OPER_OPERWALL) 
 
 #define FLAGS2_CBURST		0x10000  /* connection burst being sent */
 #define FLAGS2_PING_COOKIE	0x20000		/* PING Cookie */
@@ -460,12 +479,16 @@
                                                * been ended. */
 
 #define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | \
-                      FLAGS_ADMIN)
+                      FLAGS_ADMIN | FLAGS_SILENCE)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                       FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
                       FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
                       FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOPS | \
- 		      FLAGS_ADMIN | FLAGS_UNAUTH | FLAGS_CALLERID)
+		              FLAGS_ADMIN | FLAGS_UNAUTH | FLAGS_CALLERID | FLAGS_NS_ID | \
+      			      FLAGS_OS_ID | FLAGS_NK_ID | FLAGS_SILENCE | FLAGS_AVFH | \
+					  FLAGS_TRANSWIN | FLAGS_TRANSISO | FLAGS_NODCC | \
+					  FLAGS_NOLIST | FLAGS_NOIDLE)
+
 
 #define FLAGS_ID     (FLAGS_NEEDID | FLAGS_GOTID)
 
@@ -535,16 +558,31 @@
 #define SetCallerId(x)		((x)->umodes |= FLAGS_CALLERID)
 #define IsSetCallerId(x)	((x)->umodes & FLAGS_CALLERID)
 
-#define SetSendQExceeded(x)	((x)->flags |= FLAGS_SENDQEX)
-#define IsSendQExceeded(x)	((x)->flags & FLAGS_SENDQEX)
+#define SetSendQExceeded(x)   ((x)->flags |= FLAGS_SENDQEX)
+#define IsSendQExceeded(x)    ((x)->flags & FLAGS_SENDQEX)
 
+#define IsNetKeeper(x)          ((x)->umodes & FLAGS_NK_ID)
+#define SetNetKeeper(x)         ((x)->umodes |= FLAGS_NK_ID)
+#define ClearNetKeeper(x)       ((x)->umodes &= ~FLAGS_NK_ID)
+#define IsOSId(x)               ((x)->umodes & FLAGS_OS_ID)
+#define SetOSId(x)              ((x)->umodes |= FLAGS_OS_ID)
+#define ClearOSId(x)            ((x)->umodes &= ~FLAGS_OS_ID)
+#define IsNSId(x)               ((x)->umodes & FLAGS_NS_ID)
+#define SetNSId(x)              ((x)->umodes |= FLAGS_NS_ID)
+#define ClearNSId(x)            ((x)->umodes &= ~FLAGS_NS_ID)
+#define ClearNSId(x)            ((x)->umodes &= ~FLAGS_NS_ID)
+#define HasSilence(x)           ((x)->umodes & FLAGS_SILENCE)
+#define HasNoChannelList(x)     ((x)->umodes & FLAGS_NOLIST)
+#define SetSilence(x)           ((x)->umodes |= FLAGS_SILENCE)
+#define IsSetTransWin(x)        ((x)->umodes & FLAGS_TRANSWIN)
+#define IsSetTransISO(x)        ((x)->umodes & FLAGS_TRANSISO)
 #define SetIpHash(x)            ((x)->flags |= FLAGS_IPHASH)
 #define ClearIpHash(x)          ((x)->flags &= ~FLAGS_IPHASH)
 #define IsIpHash(x)             ((x)->flags & FLAGS_IPHASH)
 
-#define SetPingSent(x)		((x)->flags |= FLAGS_PINGSENT)
-#define IsPingSent(x)		((x)->flags & FLAGS_PINGSENT)
-#define ClearPingSent(x)	((x)->flags &= ~FLAGS_PINGSENT)
+#define SetPingSent(x)        ((x)->flags |= FLAGS_PINGSENT)
+#define IsPingSent(x)     ((x)->flags & FLAGS_PINGSENT)
+#define ClearPingSent(x)  ((x)->flags &= ~FLAGS_PINGSENT)
 
 #define SetNeedId(x)            ((x)->flags |= FLAGS_NEEDID)
 #define IsNeedId(x)             (((x)->flags & FLAGS_NEEDID) != 0)
@@ -559,8 +597,6 @@
 #define SetExemptKline(x)       ((x)->flags2 |= FLAGS2_EXEMPTKLINE)
 #define IsExemptLimits(x)       ((x)->flags2 & FLAGS2_NOLIMIT)
 #define SetExemptLimits(x)      ((x)->flags2 |= FLAGS2_NOLIMIT)
-#define IsExemptGline(x)        ((x)->flags2 & FLAGS2_EXEMPTGLINE)
-#define SetExemptGline(x)       ((x)->flags2 |= FLAGS2_EXEMPTGLINE)
 #define SetIPSpoof(x)           ((x)->flags2 |= FLAGS2_IP_SPOOFING)
 #define IsIPSpoof(x)            ((x)->flags2 & FLAGS2_IP_SPOOFING)
 
@@ -574,10 +610,11 @@
 #define SetOperGlobalKill(x)    ((x)->flags2 |= FLAGS2_OPER_GLOBAL_KILL)
 #define IsOperRemote(x)         ((x)->flags2 & FLAGS2_OPER_REMOTE)
 #define SetOperRemote(x)        ((x)->flags2 |= FLAGS2_OPER_REMOTE)
+#define IsOperOperwall(x)         ((x)->flags2 & FLAGS2_OPER_OPERWALL)
+#define SetOperOperwall(x)        ((x)->flags2 |= FLAGS2_OPER_OPERWALL)
 #define IsOperUnkline(x)        ((x)->flags2 & FLAGS2_OPER_UNKLINE)
 #define SetOperUnkline(x)       ((x)->flags2 |= FLAGS2_OPER_UNKLINE)
-#define IsOperGline(x)          ((x)->flags2 & FLAGS2_OPER_GLINE)
-#define SetOperGline(x)         ((x)->flags2 |= FLAGS2_OPER_GLINE)
+
 #define IsOperN(x)              ((x)->flags2 & FLAGS2_OPER_N)
 #define SetOperN(x)             ((x)->flags2 |= FLAGS2_OPER_N)
 #define IsOperK(x)              ((x)->flags2 & FLAGS2_OPER_K)
@@ -631,8 +668,10 @@
                              char *nick);
 extern void dead_link_on_write(struct Client *client_p, int ierrno);
 extern void dead_link_on_read(struct Client *client_p, int error);
+
 extern void exit_aborted_clients(void);
 extern void free_exited_clients(void);
 
+extern char *translate(struct Client *client_p, char *buf);
 #endif /* INCLUDED_client_h */
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/config.h ircd-hybrid-fuis/include/config.h
--- ircd-hybrid-7.0rc9/include/config.h	Thu Feb  6 03:46:11 2003
+++ ircd-hybrid-fuis/include/config.h	Sun Apr 13 12:18:57 2003
@@ -1,6 +1,6 @@
 /*
  *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
- *  config.h: The ircd compile-time-configurable header.
+ *  config.h.dist: The ircd compile-time-configurable header.
  *
  *  Copyright (C) 2002 by the past and present ircd coders, and others.
  *
@@ -102,7 +102,7 @@
 #define CPATH   ETCPATH "IRCD.CONF"             /* config file */
 #define KPATH   ETCPATH "KLINE.CONF"            /* kline file */
 #define DLPATH  ETCPATH "DLINE.CONF"            /* dline file */
-#define GPATH   LOGPATH "GLINE.LOG"             /* gline logfile */
+#define OFPATH  ETCPATH "OPERS.FILE"			/* random is operator whois file */
 #define RPATH   ETCPATH "IRCD.RSA"              /* RSA private key file */
 #define MPATH   ETCPATH "IRCD.MOTD"             /* MOTD filename */
 #define LPATH   LOGPATH "IRCD.LOG"              /* logfile */
@@ -148,7 +148,7 @@
 #define CPATH   ETCPATH "/ircd.conf"            /* ircd.conf file */
 #define KPATH   ETCPATH "/kline.conf"           /* kline file */
 #define DLPATH  ETCPATH "/dline.conf"           /* dline file */
-#define GPATH   LOGPATH "/gline.log"            /* gline logfile */
+#define OFPATH  ETCPATH "/opers.file"           /* random is operator whois file */
 #define RPATH   ETCPATH "/ircd.rsa"             /* ircd rsa private keyfile */
 #define MPATH   ETCPATH "/ircd.motd"            /* MOTD file */
 #define LPATH   LOGPATH "/ircd.log"             /* ircd logfile */
@@ -242,7 +242,7 @@
  * The number of messages that we can receive before we disconnect the
  * remote client...
  */
-#define CLIENT_FLOOD 20
+#define CLIENT_FLOOD 10
 
 /* NICKNAMEHISTORYLENGTH - size of WHOWAS array
  * this defines the length of the nickname history.  each time a user changes
@@ -296,8 +296,8 @@
  * If you have enabled efnet specific code these will be disabled automatically
  * else they are here for anyone else.
  */
-#define VCHANS
-#define ANONOPS
+#undef VCHANS
+#undef ANONOPS
 #define HALFOPS
 
 /*
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/config.h.dist ircd-hybrid-fuis/include/config.h.dist
--- ircd-hybrid-7.0rc9/include/config.h.dist	Fri Jan 17 00:21:28 2003
+++ ircd-hybrid-fuis/include/config.h.dist	Wed Mar 12 16:20:32 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: config.h.dist,v 7.59 2003/01/17 05:21:28 db Exp $
+ *  $Id: config.h,v 7.142 2003/02/06 08:46:11 a1kmm Exp $
  */
 
 #ifndef INCLUDED_config_h
@@ -102,7 +102,7 @@
 #define CPATH   ETCPATH "IRCD.CONF"             /* config file */
 #define KPATH   ETCPATH "KLINE.CONF"            /* kline file */
 #define DLPATH  ETCPATH "DLINE.CONF"            /* dline file */
-#define GPATH   LOGPATH "GLINE.LOG"             /* gline logfile */
+#define OFPATH  ETCPATH "OPERS.FILE"			/* random is operator whois file */
 #define RPATH   ETCPATH "IRCD.RSA"              /* RSA private key file */
 #define MPATH   ETCPATH "IRCD.MOTD"             /* MOTD filename */
 #define LPATH   LOGPATH "IRCD.LOG"              /* logfile */
@@ -148,7 +148,7 @@
 #define CPATH   ETCPATH "/ircd.conf"            /* ircd.conf file */
 #define KPATH   ETCPATH "/kline.conf"           /* kline file */
 #define DLPATH  ETCPATH "/dline.conf"           /* dline file */
-#define GPATH   LOGPATH "/gline.log"            /* gline logfile */
+#define OFPATH  ETCPATH "/opers.file"           /* random is operator whois file */
 #define RPATH   ETCPATH "/ircd.rsa"             /* ircd rsa private keyfile */
 #define MPATH   ETCPATH "/ircd.motd"            /* MOTD file */
 #define LPATH   LOGPATH "/ircd.log"             /* ircd logfile */
@@ -195,7 +195,7 @@
  * doc/ts5.txt for more information.  If your network has old servers
  * (hyb5, hyb6.0, +CSr) or hybserv you should NOT define this.
  */
-#undef TS5_ONLY
+#define TS5_ONLY
 
 /* USE_LOGFILE - log errors and such to LPATH
  * If you wish to have the server send 'vital' messages about server
@@ -242,7 +242,7 @@
  * The number of messages that we can receive before we disconnect the
  * remote client...
  */
-#define CLIENT_FLOOD 20
+#define CLIENT_FLOOD 10
 
 /* NICKNAMEHISTORYLENGTH - size of WHOWAS array
  * this defines the length of the nickname history.  each time a user changes
@@ -296,8 +296,8 @@
  * If you have enabled efnet specific code these will be disabled automatically
  * else they are here for anyone else.
  */
-#define VCHANS
-#define ANONOPS
+#undef VCHANS
+#undef ANONOPS
 #define HALFOPS
 
 /* END OF CONFIGURABLE OPTIONS */
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/defaults.h ircd-hybrid-fuis/include/defaults.h
--- ircd-hybrid-7.0rc9/include/defaults.h	Sat Nov 23 12:12:55 2002
+++ ircd-hybrid-fuis/include/defaults.h	Mon Feb 10 12:42:04 2003
@@ -52,8 +52,8 @@
 #define TS_WARN_DELTA_DEFAULT 30        /* default for ts_warn_delta */
 
 /* ServerInfo default values */
-#define NETWORK_NAME_DEFAULT "EFnet"             /* default for network_name */
-#define NETWORK_DESC_DEFAULT "Eris Free Network" /* default for network_desc */
+#define NETWORK_NAME_DEFAULT "FUIS"             /* default for network_name */
+#define NETWORK_DESC_DEFAULT "Free Union Of IRC Servers" /* default for network_desc */
 
 /* General defaults */
 #define MAXIMUM_LINKS_DEFAULT 1         /* default for maximum_links */
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/ircd.h ircd-hybrid-fuis/include/ircd.h
--- ircd-hybrid-7.0rc9/include/ircd.h	Thu Feb  6 03:46:10 2003
+++ ircd-hybrid-fuis/include/ircd.h	Wed Mar 12 16:18:58 2003
@@ -94,6 +94,7 @@
 #define CurrentTime SystemTime.tv_sec
 extern time_t         nextconnect;
 extern int            default_server_capabs;
+extern int            ServicesOn;
 
 extern int splitmode;
 extern int splitchecking;
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/modules.h ircd-hybrid-fuis/include/modules.h
--- ircd-hybrid-7.0rc9/include/modules.h	Tue Nov 12 08:45:40 2002
+++ ircd-hybrid-fuis/include/modules.h	Sun Feb 16 21:09:37 2003
@@ -96,7 +96,6 @@
 extern struct Message drop_msgtab;
 extern struct Message eob_msgtab;
 extern struct Message error_msgtab;
-extern struct Message gline_msgtab;
 extern struct Message help_msgtab;
 extern struct Message info_msgtab;
 extern struct Message invite_msgtab;
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/motd.h ircd-hybrid-fuis/include/motd.h
--- ircd-hybrid-7.0rc9/include/motd.h	Fri May 24 19:34:07 2002
+++ ircd-hybrid-fuis/include/motd.h	Sun Feb  9 08:21:20 2003
@@ -33,7 +33,8 @@
 typedef enum {
   USER_MOTD,
   USER_LINKS,
-  OPER_MOTD
+  OPER_MOTD,
+  OPERS_FILE
 } MotdType;
 
 struct MessageFileLine
@@ -49,6 +50,7 @@
   char             fileName[PATH_MAX + 1];
   MotdType         motdType;
   MessageFileLine* contentsOfFile;
+  int			   linecount;
   char             lastChangedDate[MAX_DATE_STRING + 1];
 };
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/numeric.h ircd-hybrid-fuis/include/numeric.h
--- ircd-hybrid-7.0rc9/include/numeric.h	Wed Nov 27 10:46:24 2002
+++ ircd-hybrid-fuis/include/numeric.h	Sun Feb 16 11:17:57 2003
@@ -113,6 +113,7 @@
 #define RPL_STATSFLINE       224
 #define RPL_STATSDLINE       225
 #define RPL_STATSALINE	     226
+#define RPL_EQUIVALENTS      228
 
 /*	RPL_RULES	     232	unreal */
 
@@ -158,6 +159,7 @@
 
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
+#define RPL_IDENTUSERS        267
 
 #define RPL_VCHANEXIST       276
 #define RPL_VCHANLIST        277
@@ -218,7 +220,6 @@
 #define RPL_WHOISUSER        311
 #define RPL_WHOISSERVER      312
 #define RPL_WHOISOPERATOR    313
-
 #define RPL_WHOWASUSER       314
 /* rpl_endofwho below (315) */
 #define RPL_ENDOFWHOWAS      369
@@ -228,22 +229,30 @@
 
 #define RPL_ENDOFWHOIS       318
 #define RPL_WHOISCHANNELS    319
+#define RPL_SERVICESCHANS    320
 /*      RPL_WHOIS_HIDDEN     320         Anothernet +h, ick! */
 /*	RPL_WHOISSPECIAL     320	unreal */
 #define RPL_LISTSTART        321
 #define RPL_LIST             322
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
+#define RPL_NS_ID 325
+#define RPL_OS_ID 326
+#define RPL_NK_ID 327
+#define RPL_SILENCE 328
 /*      RPL_CHANNELPASSIS    325           IRCnet extension */
 /*      RPL_UNIQOPIS         325           IRCnet extension */
 /*      RPL_NOCHANPASS       326           IRCnet extension */
 /*      RPL_CHPASSUNKNOWN    327           IRCnet extension */
 /*      RPL_CHANNEL_URL      328           dalnet, anothernet */
 #define RPL_CREATIONTIME     329
+#define RPL_AVFH			 330
 /*      RPL_WHOWAS_TIME      330               ? */
 #define RPL_NOTOPIC          331
 #define RPL_TOPIC            332
 #define RPL_TOPICWHOTIME     333
+#define RPL_WHOISREALHOST	 334
+#define RPL_NOLIST			 335
 /*	RPL_COMMANDSYNTAX    334	   Dalnet */
 /*	RPL_LISTSYNTAX	     334	   unreal */
 /*      RPL_CHANPASSOK       338           IRCnet extension (?)*/
@@ -275,7 +284,7 @@
 #define RPL_BANLIST          367
 #define RPL_ENDOFBANLIST     368
 /* rpl_endofwhowas above (369) */
-
+#define RPL_LINKSUSERS		 370
 #define RPL_INFO             371
 #define RPL_MOTD             372
 #define RPL_INFOSTART        373
@@ -355,6 +364,7 @@
 #define ERR_USERSDISABLED    446
 
 #define ERR_NOTREGISTERED    451
+#define ERR_NOREPEATING      452
 
 /*      ERR_IDCOLLISION      452           IRCnet extension ? */
 /*      ERR_NICKLOST         453           IRCnet extension ? */
@@ -396,6 +406,11 @@
 #define ERR_CANTKILLSERVER   483
 #define ERR_RESTRICTED       484
 #define ERR_BANNEDNICK       485
+#define ERR_SERVICESNICKHOP  486
+#define ERR_SERVICESNICKKICK 487 
+#define ERR_NOKICK			 488
+#define ERR_NOCOLOR			 489
+#define ERR_JOINF			 490
 /*	ERR_DESYNC	     484	 Dalnet,PTlink */
 /*	ERR_ATTACKDENY	     484	 unreal */
 /*	ERR_RESTRICTED	     484	   IRCnet extension */
@@ -407,7 +422,10 @@
 /*      ERR_TSLESSCHAN       488           IRCnet extension (?) */
 /*	ERR_VOICENEEDED      489           Undernet extension */
 #define ERR_NOOPERHOST       491
+#define ERR_NOCTCP       	 492
 /*      ERR_NOSERVICEHOST    492 	   IRCnet extension */
+#define ERR_NOTALK       	 493
+#define ERR_NOSPAM       	 494
 
 #define ERR_UMODEUNKNOWNFLAG 501
 #define ERR_USERSDONTMATCH   502
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/patchlevel.h ircd-hybrid-fuis/include/patchlevel.h
--- ircd-hybrid-7.0rc9/include/patchlevel.h	Thu Feb 20 00:41:04 2003
+++ ircd-hybrid-fuis/include/patchlevel.h	Thu Mar 13 13:34:55 2003
@@ -23,5 +23,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "hybrid-7.0rc9"
+#define PATCHLEVEL   "hybrid-7rc8-FUIS-p2"
 #endif
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/s_conf.h ircd-hybrid-fuis/include/s_conf.h
--- ircd-hybrid-7.0rc9/include/s_conf.h	Sat Feb 15 19:22:21 2003
+++ ircd-hybrid-fuis/include/s_conf.h	Wed Mar 12 16:18:58 2003
@@ -121,7 +121,6 @@
 #define CONF_FLAGS_SPOOF_IP             0x00000200
 #define CONF_FLAGS_SPOOF_NOTICE         0x00000400
 #define CONF_FLAGS_REDIR                0x00000800
-#define CONF_FLAGS_EXEMPTGLINE          0x00001000
 #define CONF_FLAGS_RESTRICTED           0x00002000
 #define CONF_FLAGS_CAN_FLOOD            0x00100000
 /* server flags */
@@ -131,8 +130,12 @@
 #define CONF_FLAGS_COMPRESSED           0x00020000
 #define CONF_FLAGS_TEMPORARY            0x00040000
 #define CONF_FLAGS_CRYPTLINK            0x00080000
-/* Macros for struct ConfItem */
+#define CONF_FLAGS_MASKHOST             0x00100000
+#define CONF_FLAGS_SKIPFAIL             0x00200000
+#define CONF_FLAGS_WEBCHAT              0x00400000
 
+/* Macros for struct ConfItem */
+#define IsConfSkipOnPassFail(x) ((x)->flags & CONF_FLAGS_SKIPFAIL)
 #define IsLimitIp(x)            ((x)->flags & CONF_FLAGS_LIMIT_IP)
 #define IsNoTilde(x)            ((x)->flags & CONF_FLAGS_NO_TILDE)
 #define IsConfCanFlood(x)       ((x)->flags & CONF_FLAGS_CAN_FLOOD)
@@ -141,7 +144,6 @@
 #define IsNoMatchIp(x)          ((x)->flags & CONF_FLAGS_NOMATCH_IP)
 #define IsConfExemptKline(x)    ((x)->flags & CONF_FLAGS_EXEMPTKLINE)
 #define IsConfExemptLimits(x)   ((x)->flags & CONF_FLAGS_NOLIMIT)
-#define IsConfExemptGline(x)    ((x)->flags & CONF_FLAGS_EXEMPTGLINE)
 #define IsConfIdlelined(x)      ((x)->flags & CONF_FLAGS_IDLE_LINED)
 #define IsConfDoIdentd(x)       ((x)->flags & CONF_FLAGS_DO_IDENTD)
 #define IsConfDoSpoofIp(x)      ((x)->flags & CONF_FLAGS_SPOOF_IP)
@@ -151,31 +153,36 @@
 #define IsConfEncrypted(x)      ((x)->flags & CONF_FLAGS_ENCRYPTED)
 #define IsConfCompressed(x)     ((x)->flags & CONF_FLAGS_COMPRESSED)
 #define IsConfCryptLink(x)      ((x)->flags & CONF_FLAGS_CRYPTLINK)
+#define IsConfMaskHost(x)       ((x)->flags & CONF_FLAGS_MASKHOST)
+#define IsConfWebChat(x)       ((x)->flags & CONF_FLAGS_WEBCHAT)
 
 /* port definitions for Opers */
 
 #define CONF_OPER_GLOBAL_KILL   0x0001
 #define CONF_OPER_REMOTE        0x0002
 #define CONF_OPER_UNKLINE       0x0004
-#define CONF_OPER_GLINE         0x0008
 #define CONF_OPER_N             0x0010
 #define CONF_OPER_K             0x0020
 #define CONF_OPER_REHASH        0x0040
 #define CONF_OPER_DIE           0x0080
 #define CONF_OPER_ADMIN         0x0100
+#define CONF_OPER_OPERWALL      0x0200
+
+#define MAXNETID 6
+#define MAXDREASON 120
 
 struct config_file_entry
 {
   char *dpath;          /* DPATH if set from command line */
   char *configfile;
+  char *services_host;
+  char *services_qline;
+  char *network_server_site;
   char *klinefile;
   char *dlinefile;
 
-  char *glinefile;
-
   char *logpath;
   char *operlog;
-  char *glinelog;
 
   char *servlink_path;
   char *egdpool_path;
@@ -187,7 +194,11 @@
   char fname_userlog[MAXPATHLEN];
   char fname_foperlog[MAXPATHLEN];
 
+  char netid[MAXNETID + 1];
+  char drone_reason[MAXDREASON + 1];
+
   MessageFile motd;
+  MessageFile fopers;
   MessageFile opermotd;
   MessageFile linksfile;
 
@@ -216,8 +227,6 @@
   int           short_motd;
   int           no_oper_flood;
   int           true_no_oper_flood;
-  int           glines;
-  int           gline_time;
   int           idletime;
   int           hide_server;
   int           client_exit;
@@ -229,11 +238,23 @@
   int           min_nonwildcard;
   int           default_floodcount;
   int           client_flood;
-  /* 0 == don't use throttle... */
+  int           grace_time;
+  int	        repeat_grace;
+
+  int           drone_kline;
+  int           drone_batch;
+  int           drone_rate_max;
+  int           drone_rate_period;
+  int           drone_kline_time;
+
+    /* 0 == don't use throttle... */
   int           throttle_time;
+  int			how_old;
   int           use_egd;
   int		ping_cookie;
   int           use_help;
+  int           silence_default;
+  int           no_colors_quit_msg;
 #ifdef IPV6  
   int		fallback_to_ip6_int;
 #endif
@@ -368,6 +389,9 @@
                                     char **, int *,char **);
 extern void report_configured_links(struct Client* client_p, int mask);
 extern void report_specials(struct Client* source_p, int flags, int numeric);
+extern void report_equivs(struct Client* client_p);
+extern void add_equiv_nicks(char *);
+extern char *get_equiv_nick(char *, char *);
 
 extern void yyerror(char *);
 extern int conf_yy_fatal_error(char *);
@@ -387,6 +411,17 @@
 extern  void    report_temp_klines(struct Client *);
 extern  void    show_temp_klines(struct Client *, dlink_list *);
 extern  void    cleanup_tklines(void *notused);
+
+extern void add_userpar_param(char *);
+
+extern void add_dccforb_fileext(char *);
+extern int IsDCCForb(char *);
+
+extern void add_adv_text(char *);
+extern int IsAdvQuit(char *);
+
+extern int IsUserPar(char *, char *);
+
 
 extern  const   char *get_conf_name(KlineType);
 extern  int     rehash (int);
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/s_misc.h ircd-hybrid-fuis/include/s_misc.h
--- ircd-hybrid-7.0rc9/include/s_misc.h	Fri May 24 19:34:08 2002
+++ ircd-hybrid-fuis/include/s_misc.h	Sun Feb  9 08:21:20 2003
@@ -29,8 +29,14 @@
 struct ConfItem;
 
 extern char*   date(time_t);
+extern void purge_repeats(void *);
 extern const char* smalldate(time_t);
 extern char    *small_file_date(time_t);
+extern void check_warn_drone(void *);
+extern void check_drone_queue(void *);
+
+#define DRONEMAX 20 /* fix this */
+#define CHECK_DRONE_TIME 3 /* FUIS */
 
 #define _1MEG     (1024.0)
 #define _1GIG     (1024.0*1024.0)
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/s_serv.h ircd-hybrid-fuis/include/s_serv.h
--- ircd-hybrid-7.0rc9/include/s_serv.h	Fri May 24 19:34:08 2002
+++ ircd-hybrid-fuis/include/s_serv.h	Sun Feb 16 21:09:37 2003
@@ -62,7 +62,6 @@
 #define CAP_IE          0x00000040   /* Can do invite exceptions */
 #define CAP_EOB	        0x00000100   /* Can do EOB message */
 #define CAP_KLN	        0x00000200   /* Can do KLINE message */
-#define CAP_GLN	        0x00000400   /* Can do GLINE message */
 #define CAP_HOPS        0x00000800   /* can do half ops (+h) */
 #define CAP_HUB         0x00001000   /* This server is a HUB */
 #define CAP_AOPS        0x00002000   /* Can do anon ops (+a) */
@@ -74,12 +73,13 @@
 
 #define CAP_TBURST	0x00040000   /* supports TBURST */
 #define CAP_PARA	0x00080000   /* supports invite broadcasting for +p */
+#define CAP_HOSTMASK 0x00100000  /* Can do host masking */
 
 #define CAP_MASK        (CAP_QS  | CAP_EX   | CAP_CHW  | \
                          CAP_IE  | CAP_EOB  | CAP_KLN  | \
-                         CAP_GLN | CAP_HOPS | CAP_AOPS | \
+                         CAP_HOPS | CAP_AOPS | \
                          CAP_UID | CAP_ZIP  | CAP_ENC | \
-                         CAP_KNOCK  | CAP_PARA)
+                         CAP_KNOCK  | CAP_PARA  | CAP_HOSTMASK)
 
 #ifdef HAVE_LIBZ
 #define CAP_ZIP_SUPPORTED       CAP_ZIP
@@ -252,6 +252,9 @@
 
 extern int MaxClientCount;     /* GLOBAL - highest number of clients */
 extern int MaxConnectionCount; /* GLOBAL - highest number of connections */
+extern int CurrentIdentUsers;  /* Currently identified users to services */
+extern int MaxIdentUsers;  /* Max identified users to services */
+
 
 extern int refresh_user_links;
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/s_user.h ircd-hybrid-fuis/include/s_user.h
--- ircd-hybrid-7.0rc9/include/s_user.h	Fri May 24 19:34:08 2002
+++ ircd-hybrid-fuis/include/s_user.h	Sun Feb  9 08:21:20 2003
@@ -44,7 +44,7 @@
 			   char* ,char *,char *,char *);
 
 extern int   do_remote_user(char* ,struct Client* ,struct Client*,
-			    char* ,char *,char *,char *,char *);
+			    char* ,char *,char *,char *,char *, char *);
 
 extern int   user_modes_from_c_to_bitmask[];
 extern void  show_isupport(struct Client *);
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/serno.h ircd-hybrid-fuis/include/serno.h
--- ircd-hybrid-7.0rc9/include/serno.h	Thu Feb 20 00:41:06 2003
+++ ircd-hybrid-fuis/include/serno.h	Sun Apr 13 12:22:52 2003
@@ -1 +1 @@
-#define SERIALNUM "20030220_0"
+#define SERIALNUM "20031304_1"
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/include/supported.h ircd-hybrid-fuis/include/supported.h
--- ircd-hybrid-7.0rc9/include/supported.h	Tue Jul 16 16:26:47 2002
+++ ircd-hybrid-fuis/include/supported.h	Mon Feb 17 18:58:19 2003
@@ -64,7 +64,7 @@
                         ConfigChannel.use_halfops ? "(ohv)@%+" : "(ov)@+", \
                         ConfigChannel.use_except ? "e" : "", \
                         ConfigChannel.use_invex ? "I" : "", \
-                        "b,k,l,imnpst", \
+                        "b,k,l,imMnpstCHqz", \
                         ConfigChannel.use_anonops ? "a" : "", \
                         ServerInfo.network_name, CASEMAP
 
